Model files for
"Analysis of non-Markovian repairable fault trees through rare event simulation"
by C.E. Budde, P.R. D'Argenio, R.E. Monti, and M. Stoelinga.
STTT 2021.
===============================================================================

These are all model files used for experimentation in the aforementioned paper.
Directory `FT` contains the fault trees described in the Kepler textual format.
Directory `IOSA` contains the corresponding IOSA models.

Every IOSA model was compiled from an FT using the Kepler compiler, that is part of the tool chain developed for this paper.
The Kepler compiler, developed by Raúl E. Monti, is included as part of the FIG tool in the `etc/kepler_parser/` subdirectory of its codebase.

The compiler is written in Python3 and we offer a CLI to easily translate FT into IOSA, including the generation of property queries (of unreliability and unavailability) and the STR, MCS, and MCSN importance functions presented in the paper in tables 1 and 2.
To use this CLI, standing from the base of the FIG code execute `python3 etc/kepler_parser/kompilator.py` to see a list of available options.

For instance, to create the IOSA file `DSPARE_3_rel.sa` to study unreliability, we used the following command:
```
python3 kompilator.py DSPARE_3.ft DSPARE_3_rel.sa -t 1000 -i STR MCS MCSN;
```
Similarly, to create the IOSA file `HECS_4_ava.sa` to study unavailability, we used the following command:
```
python3 kompilator.py HECS_4.ft HECS_4_ava.sa -s -i STR MCS MCSN;
```
